<?php

/**
 * This file is part of the JustKnit package.
 *
 * @copyright zahlenhexe (Iris Hammer)
 * @license GNU General Public License v2.0 (and later)
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace JustKnit\Processors\Client;

use MODX\Revolution\Processors\Model\UpdateProcessor;
use JustKnit\Model\JustKnitClientMeta;
use MODX\Revolution\modUser;
use MODX\Revolution\modUserProfile;
use MODX\Revolution\modUserGroup;
use xPDO\Om\xPDOObject;
use xPDO\Om\xPDOQuery;
use MODX\Revolution\modX;

/**
 * TODO Das Speichern der Daten in modUser und modProfile ist nicht sauber.
 *
 * Da ich die Felder
 * @modUser -> [active, createdon]
 * @modUserProfile -> [email, blocked, blockedafter, logincount, lastlogin]
 * anzeigen und verwenden will, muüssen diese Felder so behandelt werden wie in
 * @file core/src/Revolution/Processors/Security/User/Get.php beim Laden der Daten in das
 * Formular für CMP. Darin werden die Werte beim Laden formatiert und auf default Werte gesetzt.
 *
 * NOTICE: Das mache ich erst, wenn die Speicherung von @$_POST aus DS24 fertig ist.
 * Dann ist klar, ob die Felder so passen.
 *
 */


class Update extends UpdateProcessor {
    public $classKey = JustKnitClientMeta::class;
    public $objectType = 'justknit.client';
    
    public function initialize()
        {
        $test = $this->getProperties();
//        $this->modx->log(modX::LOG_LEVEL_ERROR,'$test: '. print_r($test,1));
            $this->userid = $this->getProperty('internalKey');
            return parent::initialize();
        }    
    
    /**
     * Override in your derivative class to do functionality before save() is run
     *
     * @return boolean
     */

    public function beforeSave()
    {
//        $last_name = $this->getProperty('last_name');
//        if (empty($last_name)) {
//            $this->addFieldError('last_name', $this->modx->lexicon('justknit.client_err_missing_last_name'));
//        }
        $test = $this->getProperties();
//        $this->modx->log(modX::LOG_LEVEL_ERROR,'beforeSave() $test: '. print_r($test,1));
        return parent::beforeSave();
    }

    public function process() {
        $this->modx->log(modX::LOG_LEVEL_ERROR,'$user: '. $this->userid);
$this->modx->log(modX::LOG_LEVEL_ERROR,'beforeSave() $test: '. print_r($this->getProperties(),1));
        $profile = $this->modx->getObject(modUserProfile::class, ['internalKey' => $this->userid]);
        $user = $this->modx->getObject(modUser::class, ['id' => $this->userid]);
        //$this->modx->log(modX::LOG_LEVEL_ERROR,'$Profile: '.$profile->get('email'));
        $client = $this->modx->getObject(JustKnitClientMeta::class, ['id' => $this->getProperty('id')]);

// WARNING: Hier stimmt die Variable für die Werte nicht!!!! Erledigt!!! 03.06.2023
        // set fields to formatted values
        $blockedafter = $this->getProperty('blockedafter', null);
        if ($blockedafter !== null || !empty($blockedafter) || $blockedafter !== 0) {
            $blockedafter = strtotime($blockedafter);
            $this->setProperty('blockedafter', $blockedafter);
        } else {
            $this->setProperty('blockedafter', 0);
        }
// TODO: Hier muss noch die modUserGroup richtig gesetzt werden. Der User muss Mitglied der Gruppe werden und ?? die primaryGroup muss gesetzt werden
        $profile->fromArray($this->getProperties());
        $user->fromArray($this->getProperties());
        $client->fromArray($this->getProperties());

//$this->modx->log(modX::LOG_LEVEL_ERROR,'$user: '. $user->get('username'). $this->userid.$profile->get('email') . print_r($this->getProperties(),1));
        if (!$profile->save() || !$user->save() || !$client->save()) {
            // @todo: return specific error message
            return $this->failure($this->modx->lexicon('justknit.client_err_save'));
        }
        return $this->success();
        
        
    }
}

