<?php

/**
 * This file is part of the JustKnit package.
 *
 * @copyright zahlenhexe (Iris Hammer)
 * @license GNU General Public License v2.0 (and later)
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace JustKnit\Processors\Subscriber;

use MODX\Revolution\Processors\Model\UpdateProcessor;
use JustKnit\Model\JustKnitSubscriberMeta;
use MODX\Revolution\modUser;
use MODX\Revolution\modUserProfile;
use MODX\Revolution\modUserGroup;
use xPDO\Om\xPDOObject;
use xPDO\Om\xPDOQuery;
use MODX\Revolution\modX;

class Update extends UpdateProcessor {
    public $classKey = JustKnitSubscriberMeta::class;
    public $objectType = 'justknit.subscriber';
    
    public function initialize()
        {
            $this->userid = $this->getProperty('subscriber_id');
            return parent::initialize();
        }    
    
    /**
     * Override in your derivative class to do functionality before save() is run
     *
     * @return boolean
     */

    public function beforeSave()
    {
        $last_name = $this->getProperty('last_name');
        if (empty($last_name)) {
            $this->addFieldError('last_name', $this->modx->lexicon('justknit.subscriber_err_missing_last_name'));
        }
        $test = $this->getProperties();
        $this->modx->log(modX::LOG_LEVEL_ERROR,'$test: '. print_r($test,1));
        return parent::beforeSave();
    }

    public function process() {
        $this->modx->log(modX::LOG_LEVEL_ERROR,'$user: '. $this->userid);

        $profile = $this->modx->getObject(modUserProfile::class, ['internalKey' => $this->userid]);
        $user = $this->modx->getObject(modUser::class, ['id' => $this->userid]);
        $this->modx->log(modX::LOG_LEVEL_ERROR,'$Profile: '.$profile->get('email'));
        $subscriber = $this->modx->getObject(JustKnitSubscriberMeta::class, ['id' => $this->userid]);

// WARNING: Hier stimmt die Variable für die Werte nicht!!!!
        $profile->fromArray($this->getProperties());
        $user->fromArray($this->getProperties());
        $subscriber->fromArray($this->getProperties());

$this->modx->log(modX::LOG_LEVEL_ERROR,'$user: '. $user->get('username'). $this->userid.$profile->get('email') . print_r($this->getProperties(),1));
        if (!$profile->save() || !$user->save() || !$subscriber->save()) {
            // @todo: return specific error message
            return $this->failure($this->modx->lexicon('justknit.subscriber_err_save'));
        }
        return $this->success();
        
        
    }
}

